C******** proba d'origine de genes etrangers ***********
      program etr

      include "blk.incl"

      integer prc(nt), mrc(nt), orig(nt)
      integer*2 prob(ng,nt), ann(nt), sex(nt)
      integer*2 tabp(ng,pran:dean),tabm(ng,pran:dean)
      integer i,j,k,l,n,nbit,ip,im,ngg, nl,jj,kk,ngre
      character*128 str,jour,sor
      real*8 x,y,moym(ng,pran:dean),moyf(ng,pran:dean)
      integer effm(pran:dean),efff(pran:dean)
      logical test,chy
c      real*4 t1, t2, gtimer

      call fdate(jour)
      PRINT 990,jour
      print 1000

      print 1001
      read(5,*) str
      print 1002,str
      print 1003
      read(5,*) sor
      print 1004,sor

c lecture
      open (1,file=str,form='FORMATTED')
      nl=0
      ngg=0
      chy=.false.

   10 read (1,*,end=20) i,ip,im,l,n,k
      NL=NL+1
      if (l.lt.11) then
             l=l+2000
             chy=.true.
      else if (l.lt.100) then
             l=l+1900
             chy=.true.
             end if

      if (i.ne.nl) then
          print 102,nl,i
          stop
          end if
      if (i.gt.nt.or.ip.gt.nt.or.im.gt.nt) then
          print 101
          stop
          end if

      prc(nl)=ip
      if (ip.lt.0) prc(nl)=0
      mrc(nl)=im
      if (im.lt.0) mrc(nl)=0
      orig(nl)=k
      ann(nl)=l
      sex(nl)=n
      if (l.lt.pran) ann(nl)=pran
      if (l.gt.dean) ann(nl)=dean
      if (k.gt.ngg) ngg=k
      GOTO 10

   20 if (chy) print 103
      print 900 , nl
      print 1101, ngg
      close(1)


      do i=pran, dean
        tabp(1,i)=1000
        tabm(1,i)=1000
        do j=2,ng
          tabp(j,i)=0
          tabm(j,i)=0
          end do
        end do

      j=0
  25  read (5,*,end=30) i,(tabp(ig,i),ig=1,ngg),
     *            (tabm(ig,i),ig=1,ngg)
      j=j+1
      if (j.eq.1) print 1102
      print '(21i5)',i,(tabp(ig,i),ig=1,ngg),(tabm(ig,i),ig=1,ngg)
      goto 25
  30  close(5)


c initialisations
      k=0
      do i=1, nl
         prob(1,i)=-1
	 if (prc(i).eq.0 .and. mrc(i).eq.0) then
	   k=k+1
           if (orig(i).gt.1) then
             do j=1,ngg
               prob(j,i)=0
               end do
             prob(orig(i),i)=1000
           else
             do ig=1, ngg
               prob(ig,i)=(tabp(ig,ann(i)) + tabm(ig,ann(i)))/2
               end do
             end if
	   end if
         end do

c construction de prob
c      t1=gtimer()
      nbit=0
      test=.true.
      do while(test .and. nbit.le.20)
        nbit=nbit+1
        j=0
        test=.false.
        do i=1, nl
          if (prob(1,i).eq.-1) then
            ip=prc(i)
            im=mrc(i)

            if (ip.gt.0 .and. im.gt.0) then
              if (prob(1,ip).ge.0 .and. prob(1,im).ge.0) then
                do ig=1, ngg
                  prob(ig,i)=(prob(ig,ip)+prob(ig,im))/2
                  end do
                k=k+1
                end if

            else if (ip.gt.0) then
              if (prob(1,ip).ge.0) then
                do ig=1, ngg
                  prob(ig,i)=(prob(ig,ip)+tabm(ig,ann(i)))/2
                  end do
                k=k+1
                end if

            else if (im.gt.0) then
              if (prob(1,im).ge.0) then
                do ig=1, ngg
                  prob(ig,i)=(prob(ig,im)+tabp(ig,ann(i)))/2
                  end do
                k=k+1
                end if

              end if
            end if
          end do
          if (k.lt.nl) test=.true.
        end do

c  Test qu'il n'y a pas de boucle dans le pedigree
      j=0
      if (k.ne.nl) then
        do i=1,nl
          if (prob(1,i).lt.0) then
            j=j+1
            if (j.lt.100) print '(3i10)',i,prc(i),mrc(i)
            prc(i)=0
            mrc(i)=0
            prob(1,i)=0
            end if
        end do
       end if
      if (j.gt.0) print 1104, j

c      t2=gtimer()

c sauvegarde des contributions individuelles
      if (sor.ne.'no') then
         ngre=ngg
         if (ngg.gt.10) ngre=10
         open (9,file=sor,form='formatted')
         do i=1,nl
           if (prob(1,i).lt.1000) write (9,8) i,(prob(j,i),j=1,ngre)
           end do
         end if
    8 format (11i5)

c stat
      do i=pran, dean
        effm(i)=0.d0
        efff(i)=0.d0
        do ig=1, ngg
          moym(ig,i)=0.d0
          moyf(ig,i)=0.d0
          end do
        end do
       do i=1, nl
          if (prc(i).ne.0 .and. mrc(i).ne.0) then
             ia=ann(i)
             if (sex(i).eq.1) then    ! males
                 effm(ia)=effm(ia)+1
                 do ig=1, ngg
                    moym(ig,ia)=moym(ig,ia)+prob(ig,i)
                 end do
             end if
             if (sex(i).eq.2) then
                 efff(ia)=efff(ia)+1
                 do ig=1, ngg
                    moyf(ig,ia)=moyf(ig,ia)+prob(ig,i)
                 end do
              end if
           end if
         end do
       print 1200, (ig,ig=1,ngg)
       do i=pran, dean
         if (efff(i).gt.0) then
           do ig=1, ngg
             moyf(ig,i)=moyf(ig,i)/dfloat(efff(i))
             end do
           end if
         if (efff(i).gt.0) then
           print 40, i,efff(i),(moyf(ig,i),ig=1,ngg)
           end if
        end do

       print 1210, (ig,ig=1,ngg)
       do i=pran, dean
         if (effm(i).gt.0) then
           do ig=1, ngg
             moym(ig,i)=moym(ig,i)/dfloat(effm(i))
             end do
           end if
           if (effm(i).gt.0) then
           print 40, i,effm(i),(moym(ig,i),ig=1,ngg)
   40 format (i5,i8,100f6.0)
           end if
         end do
c      print *, 'Temps cpu : ',t2-t1

      call fdate(jour)
      PRINT 991,jour

      include "format.incl"

      stop
      END
