C******** intervalles de generations

      program intgen
      implicit none

      include "blk.incl"

      integer prc(nt), mrc(nt), ndes(nt)
      integer*2 ann(nt), sex(nt)
      character*8 dnai(nt),dn
      logical pop(nt)
      real*8  eff(2,2,ande:anfi),ing(2,2,ande:anfi)
      real*8  efx(2,2,ande:anfi),inx(2,2,ande:anfi)
      real*8  efi(2,2,ande:anfi),ini(2,2,ande:anfi)
      integer i,j,k,l,n, nl,is,ip,im,i1,i2,aninc,ndia,icol,jj
      real*8  x,y,r,z
      logical t,ecr
      character*128 str,sts,jourc
      integer annee,jour,aprc,amrc, jprc,jmrc

c
      call fdate(jourc)
      PRINT 990,jourc
      print 2000
      print 1001
      read(5,*) str
      print 1002,str
      print 1011
   1  read(5,*) icol
      if (icol.lt.5) then
        print 1013
        goto 1
        end if
      print 1012,icol
      print *


c      sts='no'
c      print *,'Nom du fichier sortie (intervalles des males individuels) / no si aucun'
c      read(5,*,end=12) sts
c   12 print *,'Fichier sortie (intervalles des males individuels):',sts

       aninc=1950
       ndia=30

c read file 1
      open (1,file=str,form='FORMATTED')
      nl=0

   10 read (1,*,end=20) i,ip,im,l,n,(jj,j=6,icol-1),dn
      NL=NL+1
      if (nl.lt.5) print '(3i10,i2,1x,A8)',i,ip,im,n,dn

      if (i.ne.nl)  then
         print 102,nl,i
         stop
         end if
      if (i.gt.nt.or.ip.gt.nt.or.im.gt.nt) then
         print 101
         stop
         end if
      if (dn.eq.'0') dn='19500101'

      prc(nl)=ip
      if (ip.lt.0) prc(nl)=0
      mrc(nl)=im
      if (im.lt.0) mrc(nl)=0
      dnai(nl)=dn
      sex(nl)=n

      pop(nl)=.true.
      if (prc(nl).le.0.or.mrc(nl).le.0) pop(nl)=.false.
      if (dn.lt.'19600101'.or.dn.gt.'20201231') pop(nl)=.false.

      ndes(nl)=0
      GOTO 10

   20 print 900, nl
      close(1)
      
c compute number of progeny
      k=0
      do i=1, nl
        if (prc(i).ne.0) ndes(prc(i))=ndes(prc(i)) + 1
        if (mrc(i).ne.0) ndes(mrc(i))=ndes(mrc(i)) + 1
        end do
      do i=1, nl
        if (ndes(i).gt.0.and.pop(i)) k=k + 1
        end do

c calcul ig
      do i=ande, anfi
        do is=1, 2
          do ip=1, 2
            eff(ip,is,i)=0.
            ing(ip,is,i)=0.
            efx(ip,is,i)=0.
            inx(ip,is,i)=0.
            efi(ip,is,i)=0.
            ini(ip,is,i)=0.
            end do
          end do
        end do

      ecr=.false.
      do i=1, nl
        if (pop(i)) then
          is=sex(i)
          i1=-1
          i2=-1
          call tdate(dnai(i),jour,annee)
          call tdate(dnai(prc(i)),jprc,aprc)
          call tdate(dnai(mrc(i)),jmrc,amrc)

          if (aprc.ne.aninc) then
            x=dfloat(jour-jprc)
            if (x.gt.0.) then
              eff(1,is,annee)=eff(1,is,annee) + 1.
              ing(1,is,annee)=ing(1,is,annee) + x
              if (ndes(i).gt.0) then
                 efx(1,is,annee)=efx(1,is,annee) + 1.
                 inx(1,is,annee)=inx(1,is,annee) + x
                 end if
              if (ndes(i).ge.ndia) then
                 efi(1,is,annee)=efi(1,is,annee) + 1.
                 ini(1,is,annee)=ini(1,is,annee) + x
                 end if
              if (is.eq.1) i1=aprc
              end if
            end if
          if (amrc.ne.aninc) then
            x=dfloat(jour-jmrc)
            if (x.gt.0.) then
              eff(2,is,annee)=eff(2,is,annee) + 1.
              ing(2,is,annee)=ing(2,is,annee) + x
              if (ndes(i).gt.0) then
                 efx(2,is,annee)=efx(2,is,annee) + 1.
                 inx(2,is,annee)=inx(2,is,annee) + x
                 end if
              if (ndes(i).ge.ndia) then
                 efi(2,is,annee)=efi(2,is,annee) + 1.
                 ini(2,is,annee)=ini(2,is,annee) + x
                 end if
              if (is.eq.1) i2=amrc
              end if
            end if

          end if
        end do

      print 2100
      print 2105
      do i=ande, anfi
        r=0
        do is=1, 2
          do ip=1, 2
            x=eff(ip,is,i)
            r=r+x
            if (x.gt.0.) ing(ip,is,i)=ing(ip,is,i)/x
            end do
          end do
        if (r.gt.0.) print 112,i, ((ing(ip,is,i),ip=1,2),is=1,2),
     *         ((eff(ip,is,i),ip=1,2),is=1,2)
  112 format (i4,5x,4f8.0,5x,4f8.0)
        end do

      print 2110
      print 2105
      do i=ande, anfi
        r=0
        do is=1, 2
          do ip=1, 2
            x=efx(ip,is,i)
            r=r+x
            if (x.gt.0.) inx(ip,is,i)=inx(ip,is,i)/x
            end do
          end do
        if (r.gt.0.) print 112,i, ((inx(ip,is,i),ip=1,2),is=1,2),
     *         ((efx(ip,is,i),ip=1,2),is=1,2)
        end do

      print 2120
      print 2105
      do i=ande, anfi
        r=0
        do is=1, 2
          do ip=1, 2
            x=efi(ip,is,i)
            r=r+x
            if (x.gt.0.) ini(ip,is,i)=ini(ip,is,i)/x
            end do
          end do
        if (r.gt.0.) print 112,i, ((ini(ip,is,i),ip=1,2),is=1,2),
     *         ((efi(ip,is,i),ip=1,2),is=1,2)
        end do

      include "format.incl"

      stop
      END

      subroutine tdate(dd,jour,annee)
      integer mc(12)
      character*8 dd
      integer jour,annee
      integer m,i
      character*2 jj,mm
      character*4 aa
      data mc/0,31,59,90,120,151,181,212,243,273,304,334/
      jour=0
      annee=1950
      if (dd.lt.'19500101'.or.dd.gt.'20201231') return
      aa=dd(1:4)
      mm=dd(5:6)
      jj=dd(7:8)
      
      if (mm.gt.'12'.or.mm.lt.'01') return
      if (jj.gt.'31'.or.jj.lt.'01') return

      read(jj,'(I2)') jour
      read(mm,'(I2)') m
      read(aa,'(I4)') annee
      jour=365*(annee-1950) + mc(m) + jour
      i=0
      if (annee.ge.1952) then
        i=(annee-1952)/4
        if (annee.lt.2000) i=i+1
        end if            
      if (mod(annee,4).eq.0.and.annee.ne.2000.and.m.lt.3) i=i-1
      jour=jour+i

      return
      end
