c calcul de consanguinite
c ***********************
c fichier entree en format * : individu pere mere recode de 1 a n
c pere=0 si inconnu, mere=0 si inconnu
c fichier trie sur individu
c pas de contrainte sur l'ordre de codage des individus
c si des anomalies de genealogie sont detectees, les parents correspondants
c sont supprimes

      program meuwissen
      implicit none

      include "blk.incl"

      integer*4 i, j, k, n
      integer*4 sire(nt),dam(nt),ped(2,nt), point(nt)
      integer*4 ord(nt),rord(nt)
      real*8 d(nt),f(0:nt),l(nt)
      character*128 str,jour,sor

      call fdate(jour)
      PRINT 990,jour
      print 3000

      print 1001
      read(5,*) str
      print 1002,str

      print 1003
      read(5,*) sor
      print 1004,sor

	n=0
      open (1,file=str,form='FORMATTED')
      open (2,file=sor,form='FORMATTED')
    1 read (1,*,end=2) i, j, k
	n=n+1
      if (i.ne.n) then
        print 102,n,i
        stop
        end if
	if (i.gt.nt.or.j.gt.nt.or.k.gt.nt) then
         print 101
         stop
         end if
c      if (i.lt.1000.or.mod(i,1000).eq.0) print *,i,j,k
	sire(n)=j
      if (j.lt.0) sire(n)=0
	dam(n)=k
      if (k.lt.0) dam(n)=0
	goto 1
    2 print 900,n
	close(1)

	call comp_d
     *   (n, sire, dam, ped, f, d, l, ord,rord,point)
      close(2)

      call fdate(jour)
      PRINT 991,jour

      include "format.incl"

	stop
	end


      subroutine comp_d (n,sire, dam,ped,f,d,l,ord,rord,point)
      implicit none
      integer*4 n,sire(*),dam(*),ped(2,*),nbit,k,i
      integer*4 ord(*), rord(*),point(*),j,n_stat_f
      real*8   stat_f(100)
      real*8 f(0:n), d(*), l(*)

      nbit=0
      do i=1, n
        ord(i)=0
        end do
      k=0
      do while (k.lt.n .and. nbit.le.50)
        nbit=nbit + 1
        j=0
          do i=1, n
            if (ord(i).eq.0) then
		if (sire(i).eq.0 .or. ord(sire(i)).ne.0) then
		if (dam(i) .eq.0 .or. ord( dam(i)).ne.0) then
		  k=k+1
		  ord(i)=k
                rord(k)=i
		  end if
		  end if
		end if
	    end do
c          print *, 'recod', nbit, n, k
	  end do

c  Test qu'il n'y a pas de boucle dans le pedigree
      j=0
      if (k.ne.n) then
        do i=1,n
          if (ord(i).eq.0) then
            j=j+1
            if (j.lt.100) print '(3i8)',i,sire(i),dam(i)
            sire(i)=0
            dam(i)=0
            k=k+1
            ord(i)=k
            rord(k)=i
          end if
       end do
      if (j.gt.0) print 1104,j
      end if

      do i=1, n
	  j=rord(i)
	  ped(1,i)=sire(j)
	  ped(2,i)=dam(j)
	  if (ped(1,i).ne.0) ped(1,i)=ord(sire(j))
	  if (ped(2,i).ne.0) ped(2,i)=ord(dam(j))
        end do

	call meuw(n, ped, f, d, l, point)

	do i=1, n
	  d(rord(i))=f(i)
	  end do
 	do i=1, n
	  f(i)=d(i)
	end do

      call bin_f(n, f, stat_f)
      DO I=1,n
c          if (f(i).gt.0.d0) write (2,1999) i,f(i)
          write (2,1999) i,f(i)
 1999 format (i8,f10.5)
          end do

      include "format.incl"
	return
	end

C*** Methode de Meuwissen
      subroutine meuw(n, ped, f, d, l ,point)
	integer*4 n, ped(2,*), point(*),npp(200),np
c      real*4 t1, t2, gtimer
	integer*4 ninbr, i, j,k, ik, is, id, ks, kd
	real*8 f(0:n), d(*), l(*),r, fi

c      t1=gtimer()
      do i=1,200
        npp(i)=0
        end do

      ninbr=0
      f(0)=-1.d0
      DO i=1,n
        if (i.le.ped(1,i) .or. i.le.ped(2,i)) then
	    print *,'Probleme dans la codification du pedigree'
          print *,i, ped(1,i),ped(2,i)
          stop
          end if
        point(i)=0
        end do

      DO i=1,n
        is=ped(1,i)
        id=ped(2,i)
        ped(1,i)=max(is,id)
        ped(2,i)=min(is,id)
        d(i)=.5d0 - .25d0*(f(is)+f(id))
        if (is.eq.0.or.id.eq.0) then
           f(i)=0.d0
        else
          np=0
          fi=-1.d0
          l(i)=1.d0
          j=i
          do while(j.ne.0)
            k=j
            r=.5d0 * l(k)
            ks=ped(1,k)
            kd=ped(2,k)
            if (ks.gt.0) then
              l(ks)=l(ks) + r
              do while(point(k).gt.ks)
                k=point(k)
                end do
              if (ks.ne.point(k)) then
                point(ks)=point(k)
                point(k)=ks
                end if
              if (kd.gt.0) then
                l(kd)=l(kd) + r
                do while(point(k).gt.kd)
                  k=point(k)
                  end do
                if (kd.ne.point(k)) then
                  point(kd)=point(k)
                  point(k)=kd
                  end if
                end if
              end if
              fi=fi + l(j)*l(j)*d(j)
              l(j)=0.d0
              k=j
              j=point(j)
              point(k)=0
              np=np+1
              end do
            f(i)=fi
            if (fi.gt.0.000001d0) ninbr=ninbr + 1
            if (np.gt.200) np=200
            if (np.eq.0) stop 'erreur etrange...'
            npp(np)=npp(np)+1
            end if
          end do
c      print *,'Nb ancetres   Effectif'
c      print *,'  connus'
c      do i=1, 200
c        if (npp(i).gt.0) print 500,i,npp(i)
  500 format (i6,i10)
c        end do

c      PRINT 3000,ninbr
c 3000 FORMAT (' Nb animaux consanguins : ',I8)
c       t2=gtimer()
c       print *, 'Temps cpu : ', t2-t1
       RETURN
       END

c ... stat de consanguinit
      subroutine bin_f (n,f,stat_f)
      integer i,j,n,dim,ii,nin
      parameter (dim = 23)
      real*8  f(0:n), total
      real*8  stat_f (dim), maxf
c..   computing statistics for inbreeding.

      do i = 1, dim
         stat_f (i) = 0.d0
      end do

      maxf = 0.d0
      nin = 0
      total = 0.d0
      do i = 1, n
         ii = int(f(i) * 20.d0 + 1.d0)
         if (ii.gt.20) ii = 20
         if (f(i) .lt. 0.0000001d0) f(i) = 0.d0
         if (f(i).ne.0.d0) then
            nin = nin + 1
            total = total + f(i)
            if (f(i).gt.maxf) maxf = f(i)
            stat_f (ii) = stat_f (ii) + 1
         end if
      end do

      stat_f (21) = nin
      if (nin.gt.0) then
         stat_f (22) = total * 100.d0/ dfloat(nin)
      end if
      stat_f (23) = maxf  * 100.d0
      print 3100,n,nin,stat_f(22),stat_f(23)
      do i=1,20
        if (stat_f(i).gt.0.d0)
     *     print '(2i8,f10.0)',(i-1)*5,(i*5),stat_f(i)
        end do

      include "format.incl"

      return
      end
